<?php

class iHomefinderAdminConfiguration extends iHomefinderAdminAbstractPage {
	
	private static $instance;
	
	public static function getInstance() {
		if(!isset(self::$instance)) {
			self::$instance = new self();
		}
		return self::$instance;
	}
	
	public function registerSettings() {
		register_setting(iHomefinderConstants::OPTION_GROUP_CONFIGURATION, iHomefinderConstants::CSS_OVERRIDE_OPTION);
		register_setting(iHomefinderConstants::OPTION_GROUP_CONFIGURATION, iHomefinderConstants::COLOR_SCHEME_OPTION);
		register_setting(iHomefinderConstants::OPTION_GROUP_CONFIGURATION, iHomefinderConstants::NO_ID_OPTION);
	}
	
	protected function getContent() {
		$cssOverride = get_option(iHomefinderConstants::CSS_OVERRIDE_OPTION, null);
		if(empty($cssOverride)) {
			$cssOverride = "<style type=\"text/css\">\n\n</style>";
		}
		?>
		<h2>Configuration</h2>
		<form method="post" action="options.php">
			<?php settings_fields(iHomefinderConstants::OPTION_GROUP_CONFIGURATION); ?>
			<table class="form-table">
				<tr>
					<th>
						<label for="<?php echo iHomefinderConstants::COLOR_SCHEME_OPTION; ?>">Button Color</label>
					</th>
					<td>
						<?php $colorScheme = get_option(iHomefinderConstants::COLOR_SCHEME_OPTION, null) ?>
						<select id="<?php echo iHomefinderConstants::COLOR_SCHEME_OPTION; ?>" name="<?php echo iHomefinderConstants::COLOR_SCHEME_OPTION; ?>">
							<option value="gray" <?php if($colorScheme == "gray") { ?>selected<?php } ?>>Gray</option>
							<option value="red" <?php if($colorScheme == "red") { ?>selected<?php } ?>>Red</option>
							<option value="green" <?php if($colorScheme == "green") { ?>selected<?php } ?>>Green</option>
							<option value="orange" <?php if($colorScheme == "orange") { ?>selected<?php } ?>>Orange</option>
							<option value="blue" <?php if($colorScheme == "blue") { ?>selected<?php } ?>>Blue</option>
							<option value="light_blue" <?php if($colorScheme == "light_blue") { ?>selected<?php } ?>>Light Blue</option>
							<option value="blue_gradient" <?php if($colorScheme == "blue_gradient") { ?>selected<?php } ?>>Blue Gradient</option>
						</select>
					</td>
				</tr>
				<tr>
					<th>
						<label for="<?php echo iHomefinderConstants::CSS_OVERRIDE_OPTION; ?>">CSS Override</label>
					</th>
					<td>
						<p>To redefine an Optima Express style, paste the edited CSS inside the style tags in the field below.</p>
						<textarea id="<?php echo iHomefinderConstants::CSS_OVERRIDE_OPTION; ?>" name="<?php echo iHomefinderConstants::CSS_OVERRIDE_OPTION; ?>" style="width: 100%; height: 300px; "><?php echo $cssOverride; ?></textarea>
					</td>
				</tr>
				<tr>
					<th>Advanced</th>
					<td>
						<label for="<?php echo iHomefinderConstants::NO_ID_OPTION; ?>">Remove duplicate CSS IDs for widgets and shortcodes for improved accessibility</label>
						<input
							type="checkbox" 
							<?php if(get_option(iHomefinderConstants::NO_ID_OPTION, null) === "true") { ?>
								checked="checked"
							<?php } ?>
							value="true"
							name="<?php echo iHomefinderConstants::NO_ID_OPTION; ?>" id="<?php echo iHomefinderConstants::NO_ID_OPTION; ?>
						">
					</td>
				</tr>
			</table>
			<p class="submit">
				<button type="submit" class="button-primary">Save Changes</button>
			</p>
		</form>
		<?php
	}
	
}